Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.fasterxml.jackson.core
Class JsonGenerator

    java.lang.Object
      com.fasterxml.jackson.core.JsonGenerator

All Implemented Interfaces:
  Versioned, Closeable

Direct Known Subclasses:
  GeneratorBase, JsonGeneratorDelegate

    public abstract class JsonGenerator

extends Object
implements Closeable, Versioned

Base class that defines public API for writing JSON content. Instances are created using factory methods of a `JsonFactory` instance.

Author:
  Tatu Saloranta

Nested Class Summary
`static class` | `JsonGenerator.Feature` Enumeration that defines all togglable features for generators.

Field Summary
`protected PrettyPrinter` | `_cfgPrettyPrinter` Object that handles pretty-printing (usually additional white space to make results more human-readable) during output.

Constructor Summary
`protected` | `JsonGenerator()`

Method Summary
`boolean` | `canUseSchema(FormatSchema schema)` Method that can be used to verify that given schema can be used with this generator (using `setSchema(com.fasterxml.jackson.core.FormatSchema)`).
`abstract void` | `close()` Method called to close this generator, so that no more content can be written.
`JsonGenerator` | `configure(JsonGenerator.Feature f, boolean state)` Method for enabling or disabling specified feature: check `JsonGenerator.Feature` for list of available features.
`abstract void` | `copyCurrentEvent(JsonParser jp)` Method for copying contents of the current event that the given parser instance points to.
`abstract void` | `copyCurrentStructure(JsonParser jp)` Method for copying contents of the current event and following events that it encloses the given parser instance points to.
`abstract JsonGenerator` | `disable(JsonGenerator.Feature f)` Method for disabling specified features (check `JsonGenerator.Feature` for list of features)
`abstract JsonGenerator` | `enable(JsonGenerator.Feature f)` Method for enabling specified parser features: check `JsonGenerator.Feature` for list of available features.
`abstract void` | `flush()` Method called to flush any buffered content to the underlying target (output stream, writer), and to flush the target itself as well.
`CharacterEscapes` | `getCharacterEscapes()` Method for accessing custom escapes factory uses for `JsonGenerator`s it creates.
`abstract ObjectCodec` | `getCodec()` Method for accessing the object used for writing Java object as Json content (using method `writeObject(java.lang.Object)`).
`int` | `getHighestEscapedChar()` Accessor method for testing what is the highest unescaped character configured for this generator.
`abstract JsonStreamContext` | `getOutputContext()`
`Object` | `getOutputTarget()` Method that can be used to get access to object that is used as target for generated output; this is usually either `OutputStream` or `Writer`, depending on what generator was constructed with.
`FormatSchema` | `getSchema()` Method for accessing Schema that this parser uses, if any.
`abstract boolean` | `isClosed()` Method that can be called to determine whether this generator is closed or not.
`abstract boolean` | `isEnabled(JsonGenerator.Feature f)` Method for checking whether given feature is enabled.
`JsonGenerator` | `setCharacterEscapes(CharacterEscapes esc)` Method for defining custom escapes factory uses for `JsonGenerator`s it creates.
`abstract JsonGenerator` | `setCodec(ObjectCodec oc)` Method that can be called to set or reset the object to use for writing Java objects as JsonContent (using method `writeObject(java.lang.Object)`).
`JsonGenerator` | `setHighestNonEscapedChar(int charCode)` Method that can be called to request that generator escapes all character codes above specified code point (if positive value); or, to not escape any characters except for ones that must be escaped for the data format (if -1).
`JsonGenerator` | `setPrettyPrinter(PrettyPrinter pp)` Method for setting a custom pretty printer, which is usually used to add indentation for improved human readability.
`void` | `setSchema(FormatSchema schema)` Method to call to make this generator use specified schema.
`abstract JsonGenerator` | `useDefaultPrettyPrinter()` Convenience method for enabling pretty-printing using the default pretty printer (`DefaultPrettyPrinter`).
`abstract Version` | `version()` Accessor for finding out version of the bundle that provided this generator instance.
`void` | `writeArrayFieldStart(String fieldName)` Convenience method for outputting a field entry ("member") (that will contain a JSON Array value), and the START_ARRAY marker.
`abstract void` | `writeBinary(Base64Variant b64variant, byte[] data, int offset, int len)` Method that will output given chunk of binary data as base64 encoded, as a complete String value (surrounded by double quotes).
`void` | `writeBinary(byte[] data)` Similar to `writeBinary(Base64Variant,byte[],int,int)`, but assumes default to using the Jackson default Base64 variant (which is `Base64Variants.MIME_NO_LINEFEEDS`).
`void` | `writeBinary(byte[] data, int offset, int len)` Similar to `writeBinary(Base64Variant,byte[],int,int)`, but default to using the Jackson default Base64 variant (which is `Base64Variants.MIME_NO_LINEFEEDS`).
`void` | `writeBinaryField(String fieldName, byte[] data)` Convenience method for outputting a field entry ("member") that contains specified data in base64-encoded form.
`abstract void` | `writeBoolean(boolean state)` Method for outputting literal Json boolean value (one of Strings 'true' and 'false').
`void` | `writeBooleanField(String fieldName, boolean value)` Convenience method for outputting a field entry ("member") that has a boolean value.
`abstract void` | `writeEndArray()` Method for writing closing marker of a JSON Array value (character ']'; plus possible white space decoration if pretty-printing is enabled).
`abstract void` | `writeEndObject()` Method for writing closing marker of a JSON Object value (character '}'; plus possible white space decoration if pretty-printing is enabled).
`abstract void` | `writeFieldName(SerializableString name)` Method similar to `writeFieldName(String)`, main difference being that it may perform better as some of processing (such as quoting of certain characters, or encoding into external encoding if supported by generator) can be done just once and reused for later calls.
`abstract void` | `writeFieldName(String name)` Method for writing a field name (JSON String surrounded by double quotes: syntactically identical to a JSON String value), possibly decorated by white space if pretty-printing is enabled.
`abstract void` | `writeNull()` Method for outputting literal Json null value.
`void` | `writeNullField(String fieldName)` Convenience method for outputting a field entry ("member") that has JSON literal value null.
`abstract void` | `writeNumber(BigDecimal dec)` Method for outputting indicate Json numeric value.
`abstract void` | `writeNumber(BigInteger v)` Method for outputting given value as Json number.
`abstract void` | `writeNumber(double d)` Method for outputting indicate Json numeric value.
`abstract void` | `writeNumber(float f)` Method for outputting indicate Json numeric value.
`abstract void` | `writeNumber(int v)` Method for outputting given value as Json number.
`abstract void` | `writeNumber(long v)` Method for outputting given value as Json number.
`abstract void` | `writeNumber(String encodedValue)` Write method that can be used for custom numeric types that can not be (easily?) converted to "standard" Java number types.
`void` | `writeNumberField(String fieldName, BigDecimal value)` Convenience method for outputting a field entry ("member") that has the specified numeric value.
`void` | `writeNumberField(String fieldName, double value)` Convenience method for outputting a field entry ("member") that has the specified numeric value.
`void` | `writeNumberField(String fieldName, float value)` Convenience method for outputting a field entry ("member") that has the specified numeric value.
`void` | `writeNumberField(String fieldName, int value)` Convenience method for outputting a field entry ("member") that has the specified numeric value.
`void` | `writeNumberField(String fieldName, long value)` Convenience method for outputting a field entry ("member") that has the specified numeric value.
`abstract void` | `writeObject(Object pojo)` Method for writing given Java object (POJO) as Json.
`void` | `writeObjectField(String fieldName, Object pojo)` Convenience method for outputting a field entry ("member") that has contents of specific Java object as its value.
`void` | `writeObjectFieldStart(String fieldName)` Convenience method for outputting a field entry ("member") (that will contain a JSON Object value), and the START_OBJECT marker.
`abstract void` | `writeRaw(char c)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
`abstract void` | `writeRaw(char[] text, int offset, int len)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
`abstract void` | `writeRaw(String text)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
`abstract void` | `writeRaw(String text, int offset, int len)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
`abstract void` | `writeRawUTF8String(byte[] text, int offset, int length)` Method similar to `writeString(String)` but that takes as its input a UTF-8 encoded String that is to be output as-is, without additional escaping (type of which depends on data format; backslashes for JSON).
`abstract void` | `writeRawValue(char[] text, int offset, int len)`
`abstract void` | `writeRawValue(String text)` Method that will force generator to copy input text verbatim without any modifications, but assuming it must constitute a single legal JSON value (number, string, boolean, null, Array or List).
`abstract void` | `writeRawValue(String text, int offset, int len)`
`abstract void` | `writeStartArray()` Method for writing starting marker of a JSON Array value (character '['; plus possible white space decoration if pretty-printing is enabled).
`abstract void` | `writeStartObject()` Method for writing starting marker of a JSON Object value (character '{'; plus possible white space decoration if pretty-printing is enabled).
`abstract void` | `writeString(char[] text, int offset, int len)` Method for outputting a String value.
`abstract void` | `writeString(SerializableString text)` Method similar to `writeString(String)`, but that takes `SerializableString` which can make this potentially more efficient to call as generator may be able to reuse quoted and/or encoded representation.
`abstract void` | `writeString(String text)` Method for outputting a String value.
`void` | `writeStringField(String fieldName, String value)` Convenience method for outputting a field entry ("member") that has a String value.
`abstract void` | `writeTree(TreeNode rootNode)` Method for writing given JSON tree (expressed as a tree where given JsonNode is the root) using this generator.
`abstract void` | `writeUTF8String(byte[] text, int offset, int length)` Method similar to `writeString(String)` but that takes as its input a UTF-8 encoded String which has not been escaped using whatever escaping scheme data format requires (for JSON that is backslash-escaping for control characters and double-quotes; for other formats something else).

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### _cfgPrettyPrinter

    protected PrettyPrinter _cfgPrettyPrinter

  Object that handles pretty-printing (usually additional white space to make results more human-readable) during output. If null, no pretty-printing is done.

Constructor Detail

### JsonGenerator

    protected JsonGenerator()

Method Detail

### setSchema

    public void setSchema(FormatSchema schema)

  Method to call to make this generator use specified schema. Method must be called before generating any content, right after instance has been created. Note that not all generators support schemas; and those that do usually only accept specific types of schemas: ones defined for data format this generator produces.

  If generator does not support specified schema, `UnsupportedOperationException` is thrown.

  Parameters:
    `schema` - Schema to use
  Throws:
    `UnsupportedOperationException` - if generator does not support schema

### getSchema

    public FormatSchema getSchema()

  Method for accessing Schema that this parser uses, if any. Default implementation returns null.

  Since:
    2.1

### canUseSchema

    public boolean canUseSchema(FormatSchema schema)

  Method that can be used to verify that given schema can be used with this generator (using `setSchema(com.fasterxml.jackson.core.FormatSchema)`).

  Parameters:
    `schema` - Schema to check
  Returns:
    True if this generator can use given schema; false if not

### version

    public abstract Version version()

  Accessor for finding out version of the bundle that provided this generator instance.

  Specified by:
    `version` in interface `Versioned`

### getOutputTarget

    public Object getOutputTarget()

  Method that can be used to get access to object that is used as target for generated output; this is usually either `OutputStream` or `Writer`, depending on what generator was constructed with. Note that returned value may be null in some cases; including case where implementation does not want to exposed raw source to caller. In cases where output has been decorated, object returned here is the decorated version; this allows some level of interaction between users of generator and decorator object.

  In general use of this accessor should be considered as "last effort", i.e. only used if no other mechanism is applicable.

### enable

    public abstract JsonGenerator enable(JsonGenerator.Feature f)

  Method for enabling specified parser features: check `JsonGenerator.Feature` for list of available features.

  Returns:
    Generator itself (this), to allow chaining

### disable

    public abstract JsonGenerator disable(JsonGenerator.Feature f)

  Method for disabling specified features (check `JsonGenerator.Feature` for list of features)

  Returns:
    Generator itself (this), to allow chaining

### configure

    public final JsonGenerator configure(JsonGenerator.Feature f,
                                         boolean state)

  Method for enabling or disabling specified feature: check `JsonGenerator.Feature` for list of available features.

  Returns:
    Generator itself (this), to allow chaining

### isEnabled

    public abstract boolean isEnabled(JsonGenerator.Feature f)

  Method for checking whether given feature is enabled. Check `JsonGenerator.Feature` for list of available features.

### setCodec

    public abstract JsonGenerator setCodec(ObjectCodec oc)

  Method that can be called to set or reset the object to use for writing Java objects as JsonContent (using method `writeObject(java.lang.Object)`).

  Returns:
    Generator itself (this), to allow chaining

### getCodec

    public abstract ObjectCodec getCodec()

  Method for accessing the object used for writing Java object as Json content (using method `writeObject(java.lang.Object)`).

### setPrettyPrinter

    public JsonGenerator setPrettyPrinter(PrettyPrinter pp)

  Method for setting a custom pretty printer, which is usually used to add indentation for improved human readability. By default, generator does not do pretty printing.

  To use the default pretty printer that comes with core Jackson distribution, call `useDefaultPrettyPrinter()` instead.

  Returns:
    Generator itself (this), to allow chaining

### useDefaultPrettyPrinter

    public abstract JsonGenerator useDefaultPrettyPrinter()

  Convenience method for enabling pretty-printing using the default pretty printer (`DefaultPrettyPrinter`).

  Returns:
    Generator itself (this), to allow chaining

### setHighestNonEscapedChar

    public JsonGenerator setHighestNonEscapedChar(int charCode)

  Method that can be called to request that generator escapes all character codes above specified code point (if positive value); or, to not escape any characters except for ones that must be escaped for the data format (if -1). To force escaping of all non-ASCII characters, for example, this method would be called with value of 127.

  Note that generators are NOT required to support setting of value higher than 127, because there are other ways to affect quoting (or lack thereof) of character codes between 0 and 127. Not all generators support concept of escaping, either; if so, calling this method will have no effect.

  Default implementation does nothing; sub-classes need to redefine it according to rules of supported data format.

  Parameters:
    `charCode` - Either -1 to indicate that no additional escaping is to be done; or highest code point not to escape (meaning higher ones will be), if positive value.

### getHighestEscapedChar

    public int getHighestEscapedChar()

  Accessor method for testing what is the highest unescaped character configured for this generator. This may be either positive value (when escaping configuration has been set and is in effect), or 0 to indicate that no additional escaping is in effect. Some generators may not support additional escaping: for example, generators for binary formats that do not use escaping should simply return 0.

  Returns:
    Currently active limitation for highest non-escaped character, if defined; or -1 to indicate no additional escaping is performed.

### getCharacterEscapes

    public CharacterEscapes getCharacterEscapes()

  Method for accessing custom escapes factory uses for `JsonGenerator`s it creates.

### setCharacterEscapes

    public JsonGenerator setCharacterEscapes(CharacterEscapes esc)

  Method for defining custom escapes factory uses for `JsonGenerator`s it creates.

### writeStartArray

    public abstract void writeStartArray()
                                  throws IOException,
                                         JsonGenerationException

  Method for writing starting marker of a JSON Array value (character '['; plus possible white space decoration if pretty-printing is enabled).

  Array values can be written in any context where values are allowed: meaning everywhere except for when a field name is expected.

  Throws:
    `IOException`
    `JsonGenerationException`

### writeEndArray

    public abstract void writeEndArray()
                                throws IOException,
                                       JsonGenerationException

  Method for writing closing marker of a JSON Array value (character ']'; plus possible white space decoration if pretty-printing is enabled).

  Marker can be written if the innermost structured type is Array.

  Throws:
    `IOException`
    `JsonGenerationException`

### writeStartObject

    public abstract void writeStartObject()
                                   throws IOException,
                                          JsonGenerationException

  Method for writing starting marker of a JSON Object value (character '{'; plus possible white space decoration if pretty-printing is enabled).

  Object values can be written in any context where values are allowed: meaning everywhere except for when a field name is expected.

  Throws:
    `IOException`
    `JsonGenerationException`

### writeEndObject

    public abstract void writeEndObject()
                                 throws IOException,
                                        JsonGenerationException

  Method for writing closing marker of a JSON Object value (character '}'; plus possible white space decoration if pretty-printing is enabled).

  Marker can be written if the innermost structured type is Object, and the last written event was either a complete value, or START-OBJECT marker (see JSON specification for more details).

  Throws:
    `IOException`
    `JsonGenerationException`

### writeFieldName

    public abstract void writeFieldName(String name)
                                 throws IOException,
                                        JsonGenerationException

  Method for writing a field name (JSON String surrounded by double quotes: syntactically identical to a JSON String value), possibly decorated by white space if pretty-printing is enabled.

  Field names can only be written in Object context (check out JSON specification for details), when field name is expected (field names alternate with values).

  Throws:
    `IOException`
    `JsonGenerationException`

### writeFieldName

    public abstract void writeFieldName(SerializableString name)
                                 throws IOException,
                                        JsonGenerationException

  Method similar to `writeFieldName(String)`, main difference being that it may perform better as some of processing (such as quoting of certain characters, or encoding into external encoding if supported by generator) can be done just once and reused for later calls.

  Default implementation simple uses unprocessed name container in serialized String; implementations are strongly encouraged to make use of more efficient methods argument object has.

  Throws:
    `IOException`
    `JsonGenerationException`

### writeString

    public abstract void writeString(String text)
                              throws IOException,
                                     JsonGenerationException

  Method for outputting a String value. Depending on context this means either array element, (object) field value or a stand alone String; but in all cases, String will be surrounded in double quotes, and contents will be properly escaped as required by JSON specification.

  Throws:
    `IOException`
    `JsonGenerationException`

### writeString

    public abstract void writeString(char[] text,
                                     int offset,
                                     int len)
                              throws IOException,
                                     JsonGenerationException

  Method for outputting a String value. Depending on context this means either array element, (object) field value or a stand alone String; but in all cases, String will be surrounded in double quotes, and contents will be properly escaped as required by JSON specification.

  Throws:
    `IOException`
    `JsonGenerationException`

### writeString

    public abstract void writeString(SerializableString text)
                              throws IOException,
                                     JsonGenerationException

  Method similar to `writeString(String)`, but that takes `SerializableString` which can make this potentially more efficient to call as generator may be able to reuse quoted and/or encoded representation.

  Default implementation just calls `writeString(String)`; sub-classes should override it with more efficient implementation if possible.

  Throws:
    `IOException`
    `JsonGenerationException`

### writeRawUTF8String

    public abstract void writeRawUTF8String(byte[] text,
                                            int offset,
                                            int length)
                                     throws IOException,
                                            JsonGenerationException

  Method similar to `writeString(String)` but that takes as its input a UTF-8 encoded String that is to be output as-is, without additional escaping (type of which depends on data format; backslashes for JSON). However, quoting that data format requires (like double-quotes for JSON) will be added around the value if and as necessary.

  Note that some backends may choose not to support this method: for example, if underlying destination is a `Writer` using this method would require UTF-8 decoding. If so, implementation may instead choose to throw a `UnsupportedOperationException` due to ineffectiveness of having to decode input.

  Throws:
    `IOException`
    `JsonGenerationException`

### writeUTF8String

    public abstract void writeUTF8String(byte[] text,
                                         int offset,
                                         int length)
                                  throws IOException,
                                         JsonGenerationException

  Method similar to `writeString(String)` but that takes as its input a UTF-8 encoded String which has not been escaped using whatever escaping scheme data format requires (for JSON that is backslash-escaping for control characters and double-quotes; for other formats something else). This means that textual JSON backends need to check if value needs JSON escaping, but otherwise can just be copied as is to output. Also, quoting that data format requires (like double-quotes for JSON) will be added around the value if and as necessary.

  Note that some backends may choose not to support this method: for example, if underlying destination is a `Writer` using this method would require UTF-8 decoding. In this case generator implementation may instead choose to throw a `UnsupportedOperationException` due to ineffectiveness of having to decode input.

  Throws:
    `IOException`
    `JsonGenerationException`

### writeRaw

    public abstract void writeRaw(String text)
                           throws IOException,
                                  JsonGenerationException

  Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `writeRawValue(String)` instead.

  Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

  Throws:
    `IOException`
    `JsonGenerationException`

### writeRaw

    public abstract void writeRaw(String text,
                                  int offset,
                                  int len)
                           throws IOException,
                                  JsonGenerationException

  Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `writeRawValue(String)` instead.

  Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

  Throws:
    `IOException`
    `JsonGenerationException`

### writeRaw

    public abstract void writeRaw(char[] text,
                                  int offset,
                                  int len)
                           throws IOException,
                                  JsonGenerationException

  Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `writeRawValue(String)` instead.

  Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

  Throws:
    `IOException`
    `JsonGenerationException`

### writeRaw

    public abstract void writeRaw(char c)
                           throws IOException,
                                  JsonGenerationException

  Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `writeRawValue(String)` instead.

  Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

  Throws:
    `IOException`
    `JsonGenerationException`

### writeRawValue

    public abstract void writeRawValue(String text)
                                throws IOException,
                                       JsonGenerationException

  Method that will force generator to copy input text verbatim without any modifications, but assuming it must constitute a single legal JSON value (number, string, boolean, null, Array or List). Assuming this, proper separators are added if and as needed (comma or colon), and generator state updated to reflect this.

  Throws:
    `IOException`
    `JsonGenerationException`

### writeRawValue

    public abstract void writeRawValue(String text,
                                       int offset,
                                       int len)
                                throws IOException,
                                       JsonGenerationException

  Throws:
    `IOException`
    `JsonGenerationException`

### writeRawValue

    public abstract void writeRawValue(char[] text,
                                       int offset,
                                       int len)
                                throws IOException,
                                       JsonGenerationException

  Throws:
    `IOException`
    `JsonGenerationException`

### writeBinary

    public abstract void writeBinary(Base64Variant b64variant,
                                     byte[] data,
                                     int offset,
                                     int len)
                              throws IOException,
                                     JsonGenerationException

  Method that will output given chunk of binary data as base64 encoded, as a complete String value (surrounded by double quotes). This method defaults

  Note: because Json Strings can not contain unescaped linefeeds, if linefeeds are included (as per last argument), they must be escaped. This adds overhead for decoding without improving readability. Alternatively if linefeeds are not included, resulting String value may violate the requirement of base64 RFC which mandates line-length of 76 characters and use of linefeeds. However, all `JsonParser` implementations are required to accept such "long line base64"; as do typical production-level base64 decoders.

  Parameters:
    `b64variant` - Base64 variant to use: defines details such as whether padding is used (and if so, using which character); what is the maximum line length before adding linefeed, and also the underlying alphabet to use.
  Throws:
    `IOException`
    `JsonGenerationException`

### writeBinary

    public void writeBinary(byte[] data,
                            int offset,
                            int len)
                     throws IOException,
                            JsonGenerationException

  Similar to `writeBinary(Base64Variant,byte[],int,int)`, but default to using the Jackson default Base64 variant (which is `Base64Variants.MIME_NO_LINEFEEDS`).

  Throws:
    `IOException`
    `JsonGenerationException`

### writeBinary

    public void writeBinary(byte[] data)
                     throws IOException,
                            JsonGenerationException

  Similar to `writeBinary(Base64Variant,byte[],int,int)`, but assumes default to using the Jackson default Base64 variant (which is `Base64Variants.MIME_NO_LINEFEEDS`). Also assumes that whole byte array is to be output.

  Throws:
    `IOException`
    `JsonGenerationException`

### writeNumber

    public abstract void writeNumber(int v)
                              throws IOException,
                                     JsonGenerationException

  Method for outputting given value as Json number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

  Throws:
    `IOException`
    `JsonGenerationException`

### writeNumber

    public abstract void writeNumber(long v)
                              throws IOException,
                                     JsonGenerationException

  Method for outputting given value as Json number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

  Throws:
    `IOException`
    `JsonGenerationException`

### writeNumber

    public abstract void writeNumber(BigInteger v)
                              throws IOException,
                                     JsonGenerationException

  Method for outputting given value as Json number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

  Throws:
    `IOException`
    `JsonGenerationException`

### writeNumber

    public abstract void writeNumber(double d)
                              throws IOException,
                                     JsonGenerationException

  Method for outputting indicate Json numeric value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

  Throws:
    `IOException`
    `JsonGenerationException`

### writeNumber

    public abstract void writeNumber(float f)
                              throws IOException,
                                     JsonGenerationException

  Method for outputting indicate Json numeric value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

  Throws:
    `IOException`
    `JsonGenerationException`

### writeNumber

    public abstract void writeNumber(BigDecimal dec)
                              throws IOException,
                                     JsonGenerationException

  Method for outputting indicate Json numeric value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

  Throws:
    `IOException`
    `JsonGenerationException`

### writeNumber

    public abstract void writeNumber(String encodedValue)
                              throws IOException,
                                     JsonGenerationException,
                                     UnsupportedOperationException

  Write method that can be used for custom numeric types that can not be (easily?) converted to "standard" Java number types. Because numbers are not surrounded by double quotes, regular `writeString(java.lang.String)` method can not be used; nor `writeRaw(java.lang.String)` because that does not properly handle value separators needed in Array or Object contexts.

  Note: because of lack of type safety, some generator implementations may not be able to implement this method. For example, if a binary json format is used, it may require type information for encoding; similarly for generator-wrappers around Java objects or Json nodes. If implementation does not implement this method, it needs to throw `UnsupportedOperationException`.

  Throws:
    `IOException`
    `JsonGenerationException`
    `UnsupportedOperationException`

### writeBoolean

    public abstract void writeBoolean(boolean state)
                               throws IOException,
                                      JsonGenerationException

  Method for outputting literal Json boolean value (one of Strings 'true' and 'false'). Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

  Throws:
    `IOException`
    `JsonGenerationException`

### writeNull

    public abstract void writeNull()
                            throws IOException,
                                   JsonGenerationException

  Method for outputting literal Json null value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

  Throws:
    `IOException`
    `JsonGenerationException`

### writeObject

    public abstract void writeObject(Object pojo)
                              throws IOException,
                                     JsonProcessingException

  Method for writing given Java object (POJO) as Json. Exactly how the object gets written depends on object in question (ad on codec, its configuration); for most beans it will result in Json object, but for others Json array, or String or numeric value (and for nulls, Json null literal. NOTE: generator must have its object codec set to non-null value; for generators created by a mapping factory this is the case, for others not.

  Throws:
    `IOException`
    `JsonProcessingException`

### writeTree

    public abstract void writeTree(TreeNode rootNode)
                            throws IOException,
                                   JsonProcessingException

  Method for writing given JSON tree (expressed as a tree where given JsonNode is the root) using this generator. This will generally just call `writeObject(java.lang.Object)` with given node, but is added for convenience and to make code more explicit in cases where it deals specifically with trees.

  Throws:
    `IOException`
    `JsonProcessingException`

### writeStringField

    public void writeStringField(String fieldName,
                                 String value)
                          throws IOException,
                                 JsonGenerationException

  Convenience method for outputting a field entry ("member") that has a String value. Equivalent to:

        writeFieldName(fieldName);
        writeString(value);

  Note: many performance-sensitive implementations override this method

  Throws:
    `IOException`
    `JsonGenerationException`

### writeBooleanField

    public final void writeBooleanField(String fieldName,
                                        boolean value)
                                 throws IOException,
                                        JsonGenerationException

  Convenience method for outputting a field entry ("member") that has a boolean value. Equivalent to:

        writeFieldName(fieldName);
        writeBoolean(value);

  Throws:
    `IOException`
    `JsonGenerationException`

### writeNullField

    public final void writeNullField(String fieldName)
                              throws IOException,
                                     JsonGenerationException

  Convenience method for outputting a field entry ("member") that has JSON literal value null. Equivalent to:

        writeFieldName(fieldName);
        writeNull();

  Throws:
    `IOException`
    `JsonGenerationException`

### writeNumberField

    public final void writeNumberField(String fieldName,
                                       int value)
                                throws IOException,
                                       JsonGenerationException

  Convenience method for outputting a field entry ("member") that has the specified numeric value. Equivalent to:

        writeFieldName(fieldName);
        writeNumber(value);

  Throws:
    `IOException`
    `JsonGenerationException`

### writeNumberField

    public final void writeNumberField(String fieldName,
                                       long value)
                                throws IOException,
                                       JsonGenerationException

  Convenience method for outputting a field entry ("member") that has the specified numeric value. Equivalent to:

        writeFieldName(fieldName);
        writeNumber(value);

  Throws:
    `IOException`
    `JsonGenerationException`

### writeNumberField

    public final void writeNumberField(String fieldName,
                                       double value)
                                throws IOException,
                                       JsonGenerationException

  Convenience method for outputting a field entry ("member") that has the specified numeric value. Equivalent to:

        writeFieldName(fieldName);
        writeNumber(value);

  Throws:
    `IOException`
    `JsonGenerationException`

### writeNumberField

    public final void writeNumberField(String fieldName,
                                       float value)
                                throws IOException,
                                       JsonGenerationException

  Convenience method for outputting a field entry ("member") that has the specified numeric value. Equivalent to:

        writeFieldName(fieldName);
        writeNumber(value);

  Throws:
    `IOException`
    `JsonGenerationException`

### writeNumberField

    public final void writeNumberField(String fieldName,
                                       BigDecimal value)
                                throws IOException,
                                       JsonGenerationException

  Convenience method for outputting a field entry ("member") that has the specified numeric value. Equivalent to:

        writeFieldName(fieldName);
        writeNumber(value);

  Throws:
    `IOException`
    `JsonGenerationException`

### writeBinaryField

    public final void writeBinaryField(String fieldName,
                                       byte[] data)
                                throws IOException,
                                       JsonGenerationException

  Convenience method for outputting a field entry ("member") that contains specified data in base64-encoded form. Equivalent to:

        writeFieldName(fieldName);
        writeBinary(value);

  Throws:
    `IOException`
    `JsonGenerationException`

### writeArrayFieldStart

    public final void writeArrayFieldStart(String fieldName)
                                    throws IOException,
                                           JsonGenerationException

  Convenience method for outputting a field entry ("member") (that will contain a JSON Array value), and the START_ARRAY marker. Equivalent to:

        writeFieldName(fieldName);
        writeStartArray();

  Note: caller still has to take care to close the array (by calling {#link #writeEndArray}) after writing all values of the value Array.

  Throws:
    `IOException`
    `JsonGenerationException`

### writeObjectFieldStart

    public final void writeObjectFieldStart(String fieldName)
                                     throws IOException,
                                            JsonGenerationException

  Convenience method for outputting a field entry ("member") (that will contain a JSON Object value), and the START_OBJECT marker. Equivalent to:

        writeFieldName(fieldName);
        writeStartObject();

  Note: caller still has to take care to close the Object (by calling {#link #writeEndObject}) after writing all entries of the value Object.

  Throws:
    `IOException`
    `JsonGenerationException`

### writeObjectField

    public final void writeObjectField(String fieldName,
                                       Object pojo)
                                throws IOException,
                                       JsonProcessingException

  Convenience method for outputting a field entry ("member") that has contents of specific Java object as its value. Equivalent to:

        writeFieldName(fieldName);
        writeObject(pojo);

  Throws:
    `IOException`
    `JsonProcessingException`

### copyCurrentEvent

    public abstract void copyCurrentEvent(JsonParser jp)
                                   throws IOException,
                                          JsonProcessingException

  Method for copying contents of the current event that the given parser instance points to. Note that the method will not copy any other events, such as events contained within Json Array or Object structures.

  Calling this method will not advance the given parser, although it may cause parser to internally process more data (if it lazy loads contents of value events, for example)

  Throws:
    `IOException`
    `JsonProcessingException`

### copyCurrentStructure

    public abstract void copyCurrentStructure(JsonParser jp)
                                       throws IOException,
                                              JsonProcessingException

  Method for copying contents of the current event and following events that it encloses the given parser instance points to.

  So what constitutes enclosing? Here is the list of events that have associated enclosed events that will get copied:

  - `JsonToken.START_OBJECT`: all events up to and including matching (closing) `JsonToken.END_OBJECT` will be copied
  - `JsonToken.START_ARRAY` all events up to and including matching (closing) `JsonToken.END_ARRAY` will be copied
  - `JsonToken.FIELD_NAME` the logical value (which can consist of a single scalar value; or a sequence of related events for structured types (Json Arrays, Objects)) will be copied along with the name itself. So essentially the whole field entry (name and value) will be copied.

  After calling this method, parser will point to the last event that was copied. This will either be the event parser already pointed to (if there were no enclosed events), or the last enclosed event copied.

  Throws:
    `IOException`
    `JsonProcessingException`

### getOutputContext

    public abstract JsonStreamContext getOutputContext()

  Returns:
    Context object that can give information about logical position within generated json content.

### flush

    public abstract void flush()
                        throws IOException

  Method called to flush any buffered content to the underlying target (output stream, writer), and to flush the target itself as well.

  Throws:
    `IOException`

### isClosed

    public abstract boolean isClosed()

  Method that can be called to determine whether this generator is closed or not. If it is closed, no more output can be done.

### close

    public abstract void close()
                        throws IOException

  Method called to close this generator, so that no more content can be written.

  Whether the underlying target (stream, writer) gets closed depends on whether this generator either manages the target (i.e. is the only one with access to the target -- case if caller passes a reference to the resource such as File, but not stream); or has feature `JsonGenerator.Feature.AUTO_CLOSE_TARGET` enabled. If either of above is true, the target is also closed. Otherwise (not managing, feature not enabled), target is not closed.

  Specified by:
    `close` in interface `Closeable`
  Throws:
    `IOException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2012 fasterxml.com. All Rights Reserved.